using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using System.Runtime.ExceptionServices;
using System.Security.Permissions;
using UnityEngine;
using UnityEngine.Events;
using TMPro;
namespace mod
{
    public class StickyBehaviour: MonoBehaviour {
    private void Awake() {
      this.unstickyPropertySet = new List < PhysicalProperties > (this.StickyPropertiesToIgnore);
      this.StickyPropertiesToIgnore = null;
      this.objectLayer = LayerMask.NameToLayer("Objects");
      this.nocollisionLayer = LayerMask.NameToLayer("Debris");
    }
    private void FixedUpdate() {
      bool flag = this.isStuck && this.joint && !this.joint.connectedBody;
      bool flag2 = !this.isStuck && this.joint;
      if ((this.isStuck && !this.joint) || flag2 || flag) {
        this.DestroyJoint();
      }
    }
    private void OnCollisionEnter2D(Collision2D collision) {
      if (this.isStuck || !this.armed) {
        return;
      }
      PhysicalBehaviour phys;
      if (!this.GetPhysicalBehaviour(collision, out phys)) {
        return;
      }
      if (!this.IsStickyWith(phys)) {
        return;
      }
      this.isStuck = true;
      this.CreateJoint(phys);
    }
    private void OnJointBreak2D(Joint2D broken) {
      if (broken != this.joint) {
        return;
      }
      this.DestroyJoint();
    }
    private bool GetPhysicalBehaviour(Collision2D collision, out PhysicalBehaviour phys) {
      return Global.main.PhysicalObjectsInWorldByTransform.TryGetValue(collision.transform, out phys);
    }
    private bool IsStickyWith(PhysicalBehaviour phys) {
      return ! this.unstickyPropertySet.Contains(phys.Properties);
    }
    private void CreateJoint(PhysicalBehaviour phys) {
      if (this.joint) {
        UnityEngine.Object.Destroy(this.joint);
      }
      this.joint = base.gameObject.AddComponent < FixedJoint2D > ();
      this.joint.connectedBody = phys.rigidbody;
      base.gameObject.layer = this.nocollisionLayer;
    }
    private void DestroyJoint() {
      base.gameObject.layer = this.objectLayer;
      this.isStuck = false;
      if (this.joint) {
        UnityEngine.Object.Destroy(this.joint);
      }
    } [SkipSerialisation]
    public PhysicalProperties[] StickyPropertiesToIgnore = new PhysicalProperties[0];
    private bool isStuck;
    private List < PhysicalProperties > unstickyPropertySet;
    private FixedJoint2D joint;
    public bool armed = false;
    private int objectLayer;
    private int nocollisionLayer;
  }
  public class C4TIMER: MonoBehaviour {
    public int timer = 5;
    public static AudioClip beepclip;
    public AudioSource audioSource;
    public LightSprite pinger;
    private bool activated = false;
    private ExplosiveBehaviour explbeh;
    private void Use() {
      if (activated == false) {
        activated = true;
        StartCoroutine(Dropdown());
        if (gameObject.GetComponent < StickyBehaviour > () != null) {
          gameObject.GetComponent < StickyBehaviour > ().armed = true;
        }
      }
    }
    void Start() {
      audioSource = gameObject.GetComponent(typeof(AudioSource)) as AudioSource;
      explbeh = gameObject.GetComponent(typeof(ExplosiveBehaviour)) as ExplosiveBehaviour;
    }
    IEnumerator Dropdown() {
      while (activated) {
        yield
        return new WaitForSeconds(1.0f);
        timer--;
        pinger.Brightness = 1;
        audioSource.PlayOneShot(beepclip, 0.7F);
        //beep
        yield
        return new WaitForSeconds(0.5f);
        pinger.Brightness = 0;
        if (timer == 0) {
          explbeh.ForceImmediateExposion();
        }
        yield
        return null;
      }
    }
  }
    public class mod
    {
        public static void Main()
        {
       CategoryBuilder.Create("BATMAN", "", ModAPI.LoadSprite("logo.png"));
          
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Batman",
                    DescriptionOverride = "i am batman i am justice",
                    CategoryOverride = ModAPI.FindCategory("BATMAN"),
                    ThumbnailOverride = ModAPI.LoadSprite("BAT.jpg"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();

                        var skin = ModAPI.LoadTexture("BATMAN.png");
                        person.SetBodyTextures(skin);
                        person.SetBruiseColor(87, 87, 87); 
                        person.SetSecondBruiseColor(60, 61, 64); 
                        person.SetThirdBruiseColor(77, 79, 84);
                        person.SetRottenColour(158, 146, 40); ;
                        person.SetBloodColour(173, 24, 24);

                        var sonohead = Instance.transform.GetChild(6);
                        var childObject = new GameObject("headrobe");
                        childObject.transform.SetParent(Instance.transform.Find("Head"));
                        childObject.transform.localPosition = new Vector3(0, 0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("skihead.png");
                        childSprite.GetComponent<SpriteRenderer>().sortingLayerName = "Top";

                        var upbod = Instance.transform.GetChild(6);
                        var childObject1 = new GameObject("upbod");
                        childObject1.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
                        childObject1.transform.localPosition = new Vector3(0, 0f);
                        childObject1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject1.transform.localScale = new Vector3(1f, 1f);
                        var childSprite1 = childObject1.AddComponent<SpriteRenderer>();
                        childSprite1.sprite = ModAPI.LoadSprite("skiupbod.png");

                        var lowleg = Instance.transform.GetChild(6);
                        var childObject10 = new GameObject("larmb");
                        childObject10.transform.SetParent(Instance.transform.Find("BackLeg").Find("LowerLeg"));
                        childObject10.transform.localPosition = new Vector3(0, 0f);
                        childObject10.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject10.transform.localScale = new Vector3(1f, 1f);
                        var childSprite10 = childObject10.AddComponent<SpriteRenderer>();
                        childSprite10.sprite = ModAPI.LoadSprite("skilowleg.png");
                        childSprite10.sortingLayerName = "Bottom";

                        var lowleg1 = Instance.transform.GetChild(6);
                        var childObject11 = new GameObject("larmt");
                        childObject11.transform.SetParent(Instance.transform.Find("FrontLeg").Find("LowerLegFront"));
                        childObject11.transform.localPosition = new Vector3(0, 0f);
                        childObject11.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject11.transform.localScale = new Vector3(1f, 1f);
                        var childSprite11 = childObject11.AddComponent<SpriteRenderer>();
                        childSprite11.sprite = ModAPI.LoadSprite("skilowleg.png");


                          var upbod1 = Instance.transform.GetChild(6);
                        var childObject111 = new GameObject("upbod1");
                        childObject111.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
                        childObject111.transform.localPosition = new Vector3(0, 0f);
                        childObject111.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject111.transform.localScale = new Vector3(1f, 1f);
                        var childSprite111 = childObject111.AddComponent<SpriteRenderer>();
                        childObject111.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        childSprite111.sprite = ModAPI.LoadSprite("cape.png");


                        foreach (var head in person.Limbs)
                        {
                            head.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        }

                    }
                }
            );
  
   ModAPI.Register(
               new Modification()
               {
                   OriginalItem = ModAPI.FindSpawnable("Human"),  
                    NameOverride = "The Riddler", 
                    DescriptionOverride = "   do you want a riddle?   ", 
                    CategoryOverride = ModAPI.FindCategory("BATMAN"), 
                    ThumbnailOverride = ModAPI.LoadSprite("RE.jpg"),
                    AfterSpawn = (Instance) =>
                   {
                        var person = Instance.GetComponent<PersonBehaviour>();
                       var skin = ModAPI.LoadTexture("riddler.png"); 
                        person.SetBodyTextures(skin);
                   }
               }
           );
   ModAPI.Register(
               new Modification()
               {
                   OriginalItem = ModAPI.FindSpawnable("Human"),  
                    NameOverride = "Cat Woman ", 
                    DescriptionOverride = "mau! ", 
                    CategoryOverride = ModAPI.FindCategory("BATMAN"), 
                    ThumbnailOverride = ModAPI.LoadSprite("CA.jpg"),
                    AfterSpawn = (Instance) =>
                   {
                        var person = Instance.GetComponent<PersonBehaviour>();
                       var skin = ModAPI.LoadTexture("cat.png"); 
                        person.SetBodyTextures(skin);
                        var upbod = Instance.transform.GetChild(1);
                        var childObject1 = new GameObject("upbod");
                        childObject1.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
                        childObject1.transform.localPosition = new Vector3(0, 0f);
                        childObject1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject1.transform.localScale = new Vector3(1f, 1f);
                        var childSprite1 = childObject1.AddComponent<SpriteRenderer>();
                        childSprite1.sprite = ModAPI.LoadSprite("bobs.png");
                   }
               }
           );
    
        ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Gordon", 
                    DescriptionOverride = "  ", 
                    CategoryOverride = ModAPI.FindCategory("BATMAN"),
                    ThumbnailOverride = ModAPI.LoadSprite("GO.jpg"),  
                    AfterSpawn = (Instance) =>
                         {
                var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("Gordon.png"); 
                        person.SetBodyTextures(skin);
                    }
                }
            );
           ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Joker", 
                    DescriptionOverride = "  ", 
                    CategoryOverride = ModAPI.FindCategory("BATMAN"),
                    ThumbnailOverride = ModAPI.LoadSprite("J.jpg"),  
                    AfterSpawn = (Instance) =>
                         {
                var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("j.png"); 
                        person.SetBodyTextures(skin);
                          var sonohead = Instance.transform.GetChild(6);
                        var childObject = new GameObject("headrobe");
                        childObject.transform.SetParent(Instance.transform.Find("Head"));
                        childObject.transform.localPosition = new Vector3(0, 0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(1f, 1f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("hate.png");
                        childSprite.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                    }
                }
            );
    ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Crystal"), 
                    NameOverride = "Batarang", 
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("BATMAN"), 
                    ThumbnailOverride = ModAPI.LoadSprite("yourphoto.jpg"),
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("batarang.png"); 
                        Instance.FixColliders();
                        }
                }
             );
     ModAPI.Register(
      new Modification() {
        OriginalItem = ModAPI.FindSpawnable("Plastic Explosive"),
        NameOverride = " Sticky bomb",
        DescriptionOverride = "BAM!!!",
        CategoryOverride = ModAPI.FindCategory("BATMAN"),
        ThumbnailOverride = ModAPI.LoadSprite("zagruzheno.png"),
        AfterSpawn = (Instance) =>{
          Instance.GetComponent < SpriteRenderer > ().sprite = ModAPI.LoadSprite("bam.png");
          Instance.FixColliders();
          ExplosiveBehaviour expl = Instance.GetComponent(typeof(ExplosiveBehaviour)) as ExplosiveBehaviour;
          expl.Range = 2f;
          expl.ArmOnUse = false;
          expl.Delay = 3f;
          LightSprite glow = ModAPI.CreateLight(Instance.transform, Color.red, 2, 20) as LightSprite;
          glow.Brightness = 0;
          C4TIMER innerwork = Instance.AddComponent(typeof(C4TIMER)) as C4TIMER;
          innerwork.pinger = glow;
          AudioSource audios = Instance.AddComponent(typeof(AudioSource)) as AudioSource;
          C4TIMER.beepclip = ModAPI.LoadSound("beep.mp3");
          Instance.AddComponent(typeof(StickyBehaviour));
        }
      });
      ModAPI.Register(
               new Modification()
               {
                   OriginalItem = ModAPI.FindSpawnable("Human"),  
                    NameOverride = "Penguin", 
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("BATMAN"), 
                    ThumbnailOverride = ModAPI.LoadSprite("PI.jpg"),
                    AfterSpawn = (Instance) =>
                   {
                        var person = Instance.GetComponent<PersonBehaviour>();
                       var skin = ModAPI.LoadTexture("penguin.png"); 
                        person.SetBodyTextures(skin);
             
                        var upbod1 = Instance.transform.GetChild(6);
                        var childObject111 = new GameObject("upbod1");
                        childObject111.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        childObject111.transform.localPosition = new Vector3(0, 0f);
                        childObject111.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject111.transform.localScale = new Vector3(1f, 1f);
                        var childSprite111 = childObject111.AddComponent<SpriteRenderer>();
                        childObject111.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        childSprite111.sprite = ModAPI.LoadSprite("cloat.png");
                   }
               }
           );
        Texture2D[] TextureList2 = new Texture2D[3]
                       {
                         ModAPI.LoadTexture("1.png"),
                         ModAPI.LoadTexture("2.png"),
                         ModAPI.LoadTexture("3.png")
                       };
            ModAPI.Register(
            new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Human"),
                NameOverride = "bandit",
                DescriptionOverride = "",
                CategoryOverride = ModAPI.FindCategory("BATMAN"),
                ThumbnailOverride = ModAPI.LoadSprite("BAN.jpg"),
                AfterSpawn = (Instance) =>
                {
                 
                    var person = Instance.GetComponent<PersonBehaviour>();
                    var skin = TextureList2[new System.Random().Next(0, 3)];
                    person.SetBodyTextures(skin);
    
                }
            }
         );
          
    }
  }
}
